/*
	AbogadoPowers,XYZ etc...
	for LSI-C(86)
*/
#include <stdio.h>
#include <stdlib.h>
#include <memory.h>
#include <string.h>

unsigned char	div_header[] = { 'K', 'Z', 'D' };

void main( int ac, char **av )
{
	FILE			*in;
	FILE			*out;
	unsigned char	*buf;
	unsigned char	*filebuf;
	unsigned long	file_ed = 0;
	unsigned int	file_count = 0;
	unsigned long	header_filest = 0;
	unsigned long	header_fileed = 0;
	unsigned long	header_filesize = 0;
	char			header_filename[12];
	char			out_filename[256];
	unsigned long	nowsize;
	unsigned long	i = 0;
	unsigned long	file_tbl[256];

	printf( "AbogadoPowers KZD Divider 070701 (c)Fac.KUROHANE\n" );

	if( ac == 1 )
	{
		printf( "usage: KZDDIV <filename> <outname_prefix> <dest_dir>\n" );
		return;
	}

	in = fopen( av[1], "rb" );
	if( in == NULL )
	{
		printf( "error: can't open %s\n", av[1] );
		return;
	}

	printf( "filename: %s\n", av[1] );

	/* filesize */
	fseek( in, 0, SEEK_END );
	file_ed = ftell( in );
	fseek( in, 0, SEEK_SET );
	printf( "file_size: %lu bytes\n", file_ed );

	/* file_tbl */
	printf( "searching...\n" );

	buf = ( unsigned char *)calloc( 1, 3 );
	memset( file_tbl, 0, sizeof( file_tbl ));
	for( i = 0; i != file_ed - 3; i++ )
	{
		fseek( in, i, SEEK_SET );
		fread( buf, 3, 1, in );
		if( !memcmp( div_header, buf, 3 ))
		{
			file_tbl[file_count] = i;
			file_count++;
		}
	}
	file_tbl[file_count] = file_ed;

	printf( "\n" );

	for( i = 0; i != file_count; i++ )
	{
		header_filest = file_tbl[i];
		header_fileed = file_tbl[i+1];
		header_filesize = header_fileed - header_filest;

		sprintf( header_filename, "%s_%02d.KM", av[2], i );

		printf( "%-12s %08lX-%08lX (%lu) ",
			header_filename,
			header_filest,
			header_fileed,
			header_filesize
		);

		if( ac == 4 )
		{
			sprintf( out_filename, "%s%s", av[3], header_filename );
		} else {
			sprintf( out_filename, "%s", header_filename );
		}

		out = fopen( out_filename, "wb+" );
		if( out == NULL )
		{
			printf( "error: can't write %s\n", header_filename );
			goto end;
		}

		fseek( in, header_filest, SEEK_SET );

		filebuf = ( unsigned char * )calloc( 1, 32768 );	/* 32k */
		nowsize = header_filesize;

		while( !( nowsize < 32769 ))
		{
			fread( filebuf, 32768, 1, in );
			fwrite( filebuf, 32768, 1, out );
			nowsize -= 32768;
			printf( "." );
		}
		fread( filebuf, nowsize, 1, in );
		fwrite( filebuf, nowsize, 1, out );

		fclose( out );
		printf( ".\n" );
		free( filebuf );
	}

	printf( "\n" );
	printf( "complete.\n" );
end:;
	free( buf );
	fclose( in );

	return;
}
